diff -ruN ../nakedmudv2.2/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv2.2/src/scripts/pychar.c	Thu May 12 17:08:51 2005
+++ src/scripts/pychar.c	Fri May 27 01:30:57 2005
@@ -973,30 +831,125 @@
 };
 
 
-PyMODINIT_FUNC
-init_PyChar(void) 
-{
-    PyObject* m;
-
-    if (PyType_Ready(&PyChar_Type) < 0)
-        return;
 
-    m = Py_InitModule3("char", char_module_methods,
-                       "The char module, for all char/mob-related MUD stuff.");
+//*****************************************************************************
+// implementation of pychar.h
+//*****************************************************************************
+void PyChar_addGetSetter(const char *name, void *g, void *s, const char *doc) {
+  // make sure our list of get/setters is created
+  if(pychar_getsetters == NULL) pychar_getsetters = newList();
+
+  // make the GetSetter def
+  PyGetSetDef *def = calloc(1, sizeof(PyGetSetDef));
+  def->name        = strdup(name);
+  def->get         = (getter)g;
+  def->set         = (setter)s;
+  def->doc         = (doc ? strdup(doc) : NULL);
+  def->closure     = NULL;
+  listPut(pychar_getsetters, def);
+}
+
+void PyChar_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pychar_methods == NULL) pychar_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pychar_methods, def);
+}
+
 
-    if (m == NULL)
-      return;
 
-    Py_INCREF(&PyChar_Type);
-    PyModule_AddObject(m, "Char", (PyObject *)&PyChar_Type);
+PyMODINIT_FUNC init_PyChar(void) {
+  PyObject* m;
+
+  // add in our setters and getters for the char class
+  PyChar_addGetSetter("inv", PyChar_getinv, NULL,
+		      "returns a list of objects in the char's inventory");
+  PyChar_addGetSetter("objs", PyChar_getinv, NULL,
+		      "returns a list of objects in the char's inventory");
+  PyChar_addGetSetter("name", PyChar_getname, PyChar_setname,
+		      "handle the character's name");
+  PyChar_addGetSetter("desc", PyChar_getdesc, PyChar_setdesc,
+		      "handle the character's description");
+  PyChar_addGetSetter("rdesc", PyChar_getrdesc, PyChar_setrdesc,
+		      "handle the character's room description");
+  PyChar_addGetSetter("sex", PyChar_getsex, PyChar_setsex,
+		      "handle the character's gender");
+  PyChar_addGetSetter("race", PyChar_getrace, PyChar_setrace,
+		      "handle the character's race");
+  PyChar_addGetSetter("pos", PyChar_getposition, PyChar_setposition,
+		      "handle the character's position");
+  PyChar_addGetSetter("position", PyChar_getposition, PyChar_setposition,
+		      "handle the character's position");
+  PyChar_addGetSetter("room", PyChar_getroom, PyChar_setroom,
+		      "handle the character's room");
+  PyChar_addGetSetter("on", PyChar_geton, PyChar_seton,
+   "The furniture the character is sitting on/at. If the character is not "
+   "on furniture, None is returned. To remove a character from furniture, "
+  "then use None");
+  PyChar_addGetSetter("uid", PyChar_getuid, NULL,
+		      "the character's unique identification number");
+  PyChar_addGetSetter("vnum", PyChar_getvnum, NULL,
+		      "The virtual number for NPCs. Returns -1 for PCs");
+  PyChar_addGetSetter("is_npc", PyChar_getisnpc, NULL,
+		      "Returns 1 if the char is an NPC, and 0 otherwise.");
+  PyChar_addGetSetter("is_pc", PyChar_getispc, NULL,
+		      "Returns 1 if the char is a PC, and 0 otherwise.");
+
+  // add in all of our methods for the Char class
+  PyChar_addMethod("attach", PyChar_attach, METH_VARARGS,
+		   "attach a new script to the character.");
+  PyChar_addMethod("detach", PyChar_detach, METH_VARARGS,
+		   "detach an old script from the character.");
+  PyChar_addMethod("send", PyChar_send, METH_VARARGS,
+		   "send a message to the character.");
+  PyChar_addMethod("sendarond", PyChar_sendaround, METH_VARARGS,
+		   "send a message to everyone around the character.");
+  PyChar_addMethod("act", PyChar_act, METH_VARARGS,
+		   "make the character perform an action.");
+  PyChar_addMethod("getvar", PyChar_getvar, METH_VARARGS,
+		   "get the value of a special variable the character has.");
+  PyChar_addMethod("setvar", PyChar_setvar, METH_VARARGS,
+		   "set the value of a special variable the character has.");
+
+  // add in all the getsetters and methods
+  makePyType(&PyChar_Type, pychar_getsetters, pychar_methods);
+  deleteListWith(pychar_getsetters, free); pychar_getsetters = NULL;
+  deleteListWith(pychar_methods,    free); pychar_methods    = NULL;
+
+  // make sure the room class is ready to be made
+  if (PyType_Ready(&PyChar_Type) < 0)
+    return;
+
+  // load the module
+  m = Py_InitModule3("char", char_module_methods,
+		     "The char module, for all char/mob-related MUD stuff.");
+  
+  // make sure it loaded OK
+  if (m == NULL)
+    return;
+
+  // add the Char class to the module
+  Py_INCREF(&PyChar_Type);
+  PyModule_AddObject(m, "Char", (PyObject *)&PyChar_Type);
 }
 
+
 int PyChar_Check(PyObject *value) {
   return PyObject_TypeCheck(value, &PyChar_Type);
 }
 
 int PyChar_AsUid(PyObject *ch) {
   return ((PyChar *)ch)->uid;
+}
+
+CHAR_DATA *PyChar_AsChar(PyObject *ch) {
+  return propertyTableGet(mob_table, PyChar_AsUid(ch));
 }
 
 PyObject *
diff -ruN ../nakedmudv2.2/src/scripts/pychar.d src/scripts/pychar.d
--- ../nakedmudv2.2/src/scripts/pychar.d	Thu May 12 17:08:51 2005
+++ src/scripts/pychar.d	Fri May 27 01:33:34 2005
@@ -0,0 +1,5 @@
+scripts/pychar.d scripts/pychar.o: scripts/pychar.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h world.h room.h character.h \
+  object.h races.h handler.h utils.h scripts/pyplugs.h scripts/script.h \
+  scripts/script_set.h scripts/pychar.h scripts/pyroom.h scripts/pyobj.h \
+  char_vars/char_vars.h items/items.h
diff -ruN ../nakedmudv2.2/src/scripts/pychar.h src/scripts/pychar.h
--- ../nakedmudv2.2/src/scripts/pychar.h	Thu May 12 17:08:51 2005
+++ src/scripts/pychar.h	Fri May 27 01:30:57 2005
@@ -2,20 +2,43 @@
 #define __PYCHAR_H
 //*****************************************************************************
 //
-// py_char.h
+// pychar.h
 //
-// A python extention to allow python scripts to treat MUD characters as an
-// object within the script.
+// A python extention to allow python scripts to treat MUD chars as an
+// object within the script. If you wish to give python access to more features
+// of a char, it should NOT be done by editing pychar.c! Use PyChar_addGetSetter
+// and PyChar_addMethod in a new module implementing the feature you want to
+// give Python access to.
 //
 //*****************************************************************************
 
-/* initialize characters for use */
-PyMODINIT_FUNC
-init_PyChar(void);
-int PyChar_AsUid(PyObject *ch);
+// initialize rooms for use. This must be called AFTER all other modules
+// have added in new get/setters and methods to pyroom
+PyMODINIT_FUNC init_PyChar(void);
+PyObject        *newPyChar(CHAR_DATA *ch);
+
+CHAR_DATA   *PyChar_AsChar(PyObject *ch);
+int           PyChar_AsUid(PyObject *ch);
+
+//
+// checks to see if the PyObject is a PyChar
 int PyChar_Check(PyObject *value);
 
-PyObject *
-newPyChar(CHAR_DATA *ch);
+//
+// getters allow Python to access pieces of the Char module. Setters allow
+// Python to change pieces of the char module. Getters are called when Python
+// tries to get the value of some variable on the object, and setters are called
+// when Python tries to set the value of some variable on the object. Get and
+// Set do not both need to be supplied. Examples of how to add new getters and
+// setters is presented in pychar.c
+void PyChar_addGetSetter(const char *name, void *g, void *s, const char *doc);
+
+//
+// Adds a new method function (i.e. void *f) to the Char class. Name is the name
+// of the function, f is the PyCFunction implementing the new method, flags is
+// the type of method beings used (almost always METH_VARARGS), and dog is an
+// (optional) description of what the method does. For examples on how to add
+// new methods, see pychar.c
+void PyChar_addMethod(const char *name, void *f, int flags, const char *doc);
 
 #endif //__PYCHAR_H
diff -ruN ../nakedmudv2.2/src/scripts/pymud.c src/scripts/pymud.c
--- ../nakedmudv2.2/src/scripts/pymud.c	Thu May 12 17:08:51 2005
+++ src/scripts/pymud.c	Fri May 27 01:30:57 2005
@@ -15,13 +15,51 @@
 #include <structmember.h>
 
 #include "../mud.h"
+#include "../character.h"
 
 #include "script.h"
 #include "pyroom.h"
 #include "pychar.h"
 #include "pyobj.h"
+#include "pyplugs.h"
+
+
+
+//*****************************************************************************
+// local variables and functions
+//*****************************************************************************
+// global variables we have set.
+PyObject  *globals = NULL;
+
+// Python commands that have been added to the game
+HASHTABLE *py_cmds = NULL;
+
+
+//
+// This is the glue between python commands and normal mud commands; checks for
+// the command entry in py_cmds, and calls the appropriate function
+COMMAND(cmd_py_cmd) {
+  PyObject *func = hashGet(py_cmds, cmd);
+  if(func == NULL)
+    log_string("ERROR: Tried python command, %s, but it does not exist!\r\n", 
+	       cmd);
+  else {
+    PyObject *arglist = Py_BuildValue("Osis", newPyChar(ch), cmd, subcmd, arg);
+    PyObject *retval  = PyEval_CallObject(func, arglist);
+    // check for an error:
+    if(retval == NULL) {
+      char *tb = getPythonTraceback();
+      if(tb != NULL) {
+	log_string("Error running python command, %s:\r\n%s\r\n", cmd, tb);
+	free(tb);
+      }
+    }
+    Py_XDECREF(retval);
+    Py_XDECREF(arglist);
+  }
+}
+
 
-PyObject *globals = NULL;
 
 
 //*****************************************************************************
@@ -65,7 +103,6 @@
     return NULL;
   }
 
-  //  Py_INCREF(val);
   PyDict_SetItem(globals, key, val);
   return Py_BuildValue("i", 1);
 }
@@ -81,12 +118,53 @@
     return NULL;
   }
 
-  //  Py_INCREF(Py_None);
   PyDict_SetItem(globals, key, Py_None);
   return Py_BuildValue("i", 1);
 }
 
 
+//
+// add a new command to the mud, via a python script or module. Takes in a
+// command name, a sort_by command, the function, a subcmd int value, a minimum
+// and maximum position in the form of strings, a level, and boolean values
+// for whether the command can be performed by mobiles, and whether it 
+// interrupts actions.
+static PyObject *
+mud_add_cmd(PyObject *self, PyObject *args) {
+  PyObject *func = NULL;
+  char *name  = NULL, *sort_by = NULL, *min_pos = NULL, *max_pos = NULL,
+       *group = NULL;
+  int  subcmd = 0;
+  bool mob_ok = FALSE, interrupts = FALSE;
+  int min_pos_num, max_pos_num;
+
+  // parse all of the values
+  if (!PyArg_ParseTuple(args, "szOisssbb", &name, &sort_by, &func, &subcmd,
+  			&min_pos, &max_pos, &group, &mob_ok, &interrupts)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Could not add new command. Improper arguments supplied");
+    return NULL;
+  }
+
+  // get our positions
+  min_pos_num = posGetNum(min_pos);
+  max_pos_num = posGetNum(max_pos);
+  if(min_pos_num == POS_NONE || max_pos_num == POS_NONE) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Could not add new command. Invalid position names.");
+    return NULL;
+  }
+
+  // map our python function to its command name 
+  Py_INCREF(func);
+  hashPut(py_cmds, name, func);
+  add_cmd(name, sort_by, cmd_py_cmd, subcmd, min_pos_num, max_pos_num,
+	  group, mob_ok, interrupts);
+  return Py_None;
+}
+
+
+
 
 //*****************************************************************************
 //
@@ -100,6 +178,8 @@
      "Set the value of a global variable."},
     {"erase_global",  mud_erase_global, METH_VARARGS,
      "Erase the value of a global variable."},
+    {"add_cmd", mud_add_cmd, METH_VARARGS,
+     "Add a new command to the game,"},
     {NULL, NULL, 0, NULL}        /* Sentinel */
 };
 
@@ -113,4 +193,6 @@
 
   m = Py_InitModule3("mud", mud_module_methods,
 		     "The mud module, for all MUD misc mud utils.");
+
+  py_cmds = newHashtable();
 }
diff -ruN ../nakedmudv2.2/src/scripts/pymud.d src/scripts/pymud.d
--- ../nakedmudv2.2/src/scripts/pymud.d	Thu May 12 17:08:51 2005
+++ src/scripts/pymud.d	Fri May 27 01:33:34 2005
@@ -0,0 +1,3 @@
+scripts/pymud.d scripts/pymud.o: scripts/pymud.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h character.h scripts/script.h \
+  scripts/pyroom.h scripts/pychar.h scripts/pyobj.h scripts/pyplugs.h
diff -ruN ../nakedmudv2.2/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv2.2/src/scripts/pyobj.c	Thu May 12 17:08:51 2005
+++ src/scripts/pyobj.c	Fri May 27 01:30:57 2005
@@ -19,6 +19,7 @@
 #include "../handler.h"
 #include "../utils.h"
 
+#include "pyplugs.h"
 #include "script.h"
 #include "script_set.h"
 #include "pychar.h"
@@ -26,24 +27,32 @@
 #include "pyobj.h"
 
 
+
+
+//*****************************************************************************
+// local structures and defines
+//*****************************************************************************
+// a list of the get/setters on the Obj class
+LIST *pyobj_getsetters = NULL;
+
+// a list of the methods on the Obj class
+LIST *pyobj_methods = NULL;
+
 typedef struct {
   PyObject_HEAD
   int uid;
 } PyObj;
 
 
+
 //*****************************************************************************
-//
-// allocation, deallocation, and initialiation
-//
+// allocation, deallocation, initialization, and comparison
 //*****************************************************************************
-static void
-PyObj_dealloc(PyObj *self) {
+void PyObj_dealloc(PyObj *self) {
   self->ob_type->tp_free((PyObject*)self);
 }
 
-static PyObject *
-PyObj_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
+PyObject *PyObj_new(PyTypeObject *type, PyObject *args, PyObject *kwds) {
     PyObj *self;
 
     self = (PyObj  *)type->tp_alloc(type, 0);
@@ -51,9 +60,8 @@
     return (PyObject *)self;
 }
 
-static int
-PyObj_init(PyObj *self, PyObject *args, PyObject *kwds) {
-  static char *kwlist[] = {"uid", NULL};
+int PyObj_init(PyObj *self, PyObject *args, PyObject *kwds) {
+  char *kwlist[] = {"uid", NULL};
   int uid = NOTHING;
 
   // get the universal id
@@ -74,119 +82,50 @@
   return 0;
 }
 
-
-
-
-//*****************************************************************************
-//
-// methods and stuff for building the class
-//
-//*****************************************************************************
-
-static PyObject *
-PyObj_attach(PyObj *self, PyObject *args) {  
-  long vnum = NOTHING;
-
-  // make sure we're getting passed the right type of data
-  if (!PyArg_ParseTuple(args, "i", &vnum)) {
-    PyErr_Format(PyExc_TypeError, 
-		 "To attach a script, the vnum must be suppplied.");
-    return NULL;
-  }
-
-  // pull out the character and do the attaching
-  OBJ_DATA       *obj = propertyTableGet(obj_table, self->uid);
-  SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
-  if(obj != NULL && script != NULL) {
-    scriptSetAdd(objGetScripts(obj), vnum);
-    return Py_BuildValue("i", 1);
-  }
-  else {
-    PyErr_Format(PyExc_TypeError, 
-		 "Tried to attach script to nonexistant obj, %d, or script %d "
-		 "does not exit.", self->uid, (int)vnum);
-    return NULL;
-  }
-}
-
-
-static PyObject *
-PyObj_detach(PyObj *self, PyObject *args) {  
-  long vnum = NOTHING;
-
-  // make sure we're getting passed the right type of data
-  if (!PyArg_ParseTuple(args, "i", &vnum)) {
-    PyErr_Format(PyExc_TypeError, 
-		 "To detach a script, the vnum must be suppplied.");
-    return NULL;
-  }
-
-  // pull out the character and do the attaching
-  OBJ_DATA       *obj = propertyTableGet(obj_table, self->uid);
-  SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
-  if(obj != NULL && script != NULL) {
-    scriptSetRemove(objGetScripts(obj), vnum);
-    return Py_BuildValue("i", 1);
-  }
-  else {
-    PyErr_Format(PyExc_TypeError, 
-		 "Tried to detach script from nonexistant obj, %d, or script "
-		 "%d does not exit.", self->uid, (int)vnum);
-    return NULL;
-  }
+int PyObj_compare(PyObj *obj1, PyObj *obj2) {
+  if(obj1->uid == obj2->uid)
+    return 0;
+  else if(obj1->uid < obj2->uid)
+    return -1;
+  else
+    return 1;
 }
 
 
-static PyMethodDef PyObj_methods[] = {
-  {"attach", (PyCFunction)PyObj_attach, METH_VARARGS,
-   "attach a new script to the object." },
-  {"detach", (PyCFunction)PyObj_detach, METH_VARARGS,
-   "detach a script from the object." },
-  {NULL}  /* Sentinel */
-};
-
 
 //*****************************************************************************
-//
-// character attributes - mostly get and set
-//
+// getters and setters for the Obj class
 //*****************************************************************************
-static PyObject *
-PyObj_getname(PyObj *self, void *closure) {
-  OBJ_DATA *obj = propertyTableGet(obj_table, self->uid);
+PyObject *PyObj_getname(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj != NULL) return Py_BuildValue("s", objGetName(obj));
   else           return NULL;
 }
 
-static PyObject *
-PyObj_getdesc(PyObj *self, void *closure) {
-  OBJ_DATA *obj = propertyTableGet(obj_table, self->uid);
+PyObject *PyObj_getdesc(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj != NULL) return Py_BuildValue("s", objGetDesc(obj));
   else           return NULL;
 }
 
-static PyObject *
-PyObj_getrdesc(PyObj *self, void *closure) {
-  OBJ_DATA *obj = propertyTableGet(obj_table, self->uid);
+PyObject *PyObj_getrdesc(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj != NULL) return Py_BuildValue("s", objGetRdesc(obj));
   else           return NULL;
 }
 
-static PyObject *
-PyObj_getuid(PyObj *self, void *closure) {
+PyObject *PyObj_getuid(PyObj *self, void *closure) {
   return Py_BuildValue("i", self->uid);
 }
 
-static PyObject *
-PyObj_getvnum(PyObj *self, void *closure) {
-  OBJ_DATA *obj = propertyTableGet(obj_table, self->uid);
+PyObject *PyObj_getvnum(PyObj *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj != NULL) return Py_BuildValue("i", objGetVnum(obj));
   else           return NULL;
 }
 
-static PyObject *
-PyObj_getcontents(PyObj *self, PyObject *args) {
-  OBJ_DATA *obj = propertyTableGet(obj_table, self->uid);
+PyObject *PyObj_getcontents(PyObj *self, PyObject *args) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj == NULL) 
     return NULL;
 
@@ -201,9 +140,8 @@
   return Py_BuildValue("O", list);
 }
 
-static PyObject *
-PyObj_getchars(PyObj *self, PyObject *args) {
-  OBJ_DATA *obj = propertyTableGet(obj_table, self->uid);
+PyObject *PyObj_getchars(PyObj *self, PyObject *args) {
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
   if(obj == NULL) 
     return NULL;
 
@@ -223,7 +161,6 @@
 // Standard check to make sure the object exists when
 // trying to set a value for it. If successful, assign the
 // object to ch. Otherwise, return -1 (error)
-//
 #define PYOBJ_CHECK_OBJ_EXISTS(uid, obj)                                       \
   obj = propertyTableGet(obj_table, uid);                                      \
   if(obj == NULL) {                                                            \
@@ -232,8 +169,7 @@
     return -1;                                                                 \
   }                                                                            
 
-static int
-PyObj_setname(PyObj *self, PyObject *value, void *closure) {
+int PyObj_setname(PyObj *self, PyObject *value, void *closure) {
   if (value == NULL) {
     PyErr_Format(PyExc_TypeError, "Cannot delete object's name");
     return -1;
@@ -251,8 +187,7 @@
   return 0;
 }
 
-static int
-PyObj_setdesc(PyObj *self, PyObject *value, void *closure) {
+int PyObj_setdesc(PyObj *self, PyObject *value, void *closure) {
   if (value == NULL) {
     PyErr_Format(PyExc_TypeError, "Cannot delete object's description");
     return -1;
@@ -270,8 +205,7 @@
   return 0;
 }
 
-static int
-PyObj_setrdesc(PyObj *self, PyObject *value, void *closure) {
+int PyObj_setrdesc(PyObj *self, PyObject *value, void *closure) {
   if (value == NULL) {
     PyErr_Format(PyExc_TypeError, "Cannot delete object's rdesc");
     return -1;
@@ -290,56 +224,67 @@
 }
 
 
-static PyGetSetDef PyObj_getseters[] = {
-  {"contents", (getter)PyObj_getcontents, (setter)NULL,
-   "the object's contents",
-   NULL},
-  {"objs", (getter)PyObj_getcontents, (setter)NULL,
-   "the object's contents",
-   NULL},
-  {"chars", (getter)PyObj_getchars, (setter)NULL,
-   "the characters sitting on/riding the object",
-   NULL},
-  {"name", (getter)PyObj_getname, (setter)PyObj_setname,
-   "the object's name",
-   NULL},
-  {"desc", (getter)PyObj_getdesc, (setter)PyObj_setdesc,
-   "the object's description",
-   NULL},
-  {"rdesc", (getter)PyObj_getrdesc, (setter)PyObj_setrdesc,
-   "the object's room description",
-   NULL},
-  {"uid", (getter)PyObj_getuid, (setter)NULL,
-   "the unique identification number",
-   NULL},
-  {"vnum", (getter)PyObj_getvnum, (setter)NULL,
-   "the virtual number for the object.",
-   NULL},
-  {NULL}  /* Sentinel */
-};
-
-
 
 //*****************************************************************************
-//
-// comparators, getattr, setattr, and all that other class stuff
-//
+// methods for the obj class
 //*****************************************************************************
+PyObject *PyObj_attach(PyObj *self, PyObject *args) {  
+  long vnum = NOTHING;
 
-//
-// compare one object to another
-//
-static int
-PyObj_compare(PyObj *obj1, PyObj *obj2) {
-  if(obj1->uid == obj2->uid)
-    return 0;
-  else if(obj1->uid < obj2->uid)
-    return -1;
-  else
-    return 1;
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "i", &vnum)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "To attach a script, the vnum must be suppplied.");
+    return NULL;
+  }
+
+  // pull out the character and do the attaching
+  OBJ_DATA       *obj = PyObj_AsObj((PyObject *)self);
+  SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+  if(obj != NULL && script != NULL) {
+    scriptSetAdd(objGetScripts(obj), vnum);
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to attach script to nonexistant obj, %d, or script %d "
+		 "does not exit.", self->uid, (int)vnum);
+    return NULL;
+  }
 }
 
-static PyTypeObject PyObj_Type = {
+
+PyObject *PyObj_detach(PyObj *self, PyObject *args) {  
+  long vnum = NOTHING;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "i", &vnum)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "To detach a script, the vnum must be suppplied.");
+    return NULL;
+  }
+
+  // pull out the character and do the attaching
+  OBJ_DATA       *obj = PyObj_AsObj((PyObject *)self);
+  SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+  if(obj != NULL && script != NULL) {
+    scriptSetRemove(objGetScripts(obj), vnum);
+    return Py_BuildValue("i", 1);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, 
+		 "Tried to detach script from nonexistant obj, %d, or script "
+		 "%d does not exit.", self->uid, (int)vnum);
+    return NULL;
+  }
+}
+
+
+
+//*****************************************************************************
+// structures to define our methods and classes
+//*****************************************************************************
+PyTypeObject PyObj_Type = {
     PyObject_HEAD_INIT(NULL)
     0,                         /*ob_size*/
     "obj.Obj",                 /*tp_name*/
@@ -368,9 +313,9 @@
     0,		               /* tp_weaklistoffset */
     0,		               /* tp_iter */
     0,		               /* tp_iternext */
-    PyObj_methods,             /* tp_methods */
+    0,                         /* tp_methods */
     0,                         /* tp_members */
-    PyObj_getseters,           /* tp_getset */
+    0,                         /* tp_getset */
     0,                         /* tp_base */
     0,                         /* tp_dict */
     0,                         /* tp_descr_get */
@@ -384,12 +329,9 @@
 
 
 //*****************************************************************************
-//
 // the obj module
-//
 //*****************************************************************************
-static PyObject *
-PyObj_load_obj(PyObject *self, PyObject *args) {
+PyObject *PyObj_load_obj(PyObject *self, PyObject *args) {
   int obj_vnum = NOBODY;
   PyObject *in = NULL;
 
@@ -467,8 +409,7 @@
 }
 
 
-static PyObject *
-PyObj_count_objs(PyObject *self, PyObject *args) {
+PyObject *PyObj_count_objs(PyObject *self, PyObject *args) {
   LIST *list      = NULL;
   PyObject *tgt;
   PyObject *in    = NULL;
@@ -524,8 +465,7 @@
 }
 
 
-static PyObject *
-PyObj_find_obj(PyObject *self, PyObject *args) {
+PyObject *PyObj_find_obj(PyObject *self, PyObject *args) {
   LIST *list           = object_list;
   PyObject *in         = NULL;
   ROOM_DATA *room      = NULL;
@@ -584,9 +524,7 @@
   }
 }
 
-
-
-static PyMethodDef obj_module_methods[] = {
+PyMethodDef obj_module_methods[] = {
   { "load_obj", PyObj_load_obj, METH_VARARGS,
     "load a object with the specified vnum to a room." },
   { "count_objs", PyObj_count_objs, METH_VARARGS,
@@ -600,30 +538,96 @@
 
 
 
+//*****************************************************************************
+// implementation of pyobj.h
+//*****************************************************************************
+void PyObj_addGetSetter(const char *name, void *g, void *s, const char *doc) {
+  // make sure our list of get/setters is created
+  if(pyobj_getsetters == NULL) pyobj_getsetters = newList();
+
+  // make the GetSetter def
+  PyGetSetDef *def = calloc(1, sizeof(PyGetSetDef));
+  def->name        = strdup(name);
+  def->get         = (getter)g;
+  def->set         = (setter)s;
+  def->doc         = (doc ? strdup(doc) : NULL);
+  def->closure     = NULL;
+  listPut(pyobj_getsetters, def);
+}
+
+void PyObj_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pyobj_methods == NULL) pyobj_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pyobj_methods, def);
+}
+
 PyMODINIT_FUNC
-init_PyObj(void) 
-{
+init_PyObj(void) {
     PyObject* m;
 
+    // getters and setters
+    PyObj_addGetSetter("contents", PyObj_getcontents, NULL,
+		       "the object's contents");
+    PyObj_addGetSetter("objs", PyObj_getcontents, NULL,
+		       "the object's contents");
+    PyObj_addGetSetter("chars", PyObj_getchars, NULL,
+		       "the characters sitting on/riding the object");
+    PyObj_addGetSetter("name", PyObj_getname, PyObj_setname,
+		       "the object's name");
+    PyObj_addGetSetter("desc", PyObj_getdesc, PyObj_setdesc,
+		       "the object's long description");
+    PyObj_addGetSetter("rdesc", PyObj_getrdesc, PyObj_setrdesc,
+		       "the object's room description");
+    PyObj_addGetSetter("uid", PyObj_getuid, NULL,
+		       "the object's unique identification number");
+    PyObj_addGetSetter("vnum", PyObj_getvnum, NULL,
+		       "the virtual number for the object.");
+
+    // methods
+    PyObj_addMethod("attach", PyObj_attach, METH_VARARGS,
+		    "attach a new script to the object");
+    PyObj_addMethod("detach", PyObj_detach, METH_VARARGS,
+		    "detach an old script from the object, by vnum");
+
+    makePyType(&PyObj_Type, pyobj_getsetters, pyobj_methods);
+    deleteListWith(pyobj_getsetters, free); pyobj_getsetters = NULL;
+    deleteListWith(pyobj_methods,    free); pyobj_methods    = NULL;
+
+    // make sure the obj class is ready to be made
     if (PyType_Ready(&PyObj_Type) < 0)
         return;
 
+    // make the obj module
     m = Py_InitModule3("obj", obj_module_methods,
                        "The object module, for all object-related MUD stuff.");
 
+    // make sure the obj module parsed OK
     if (m == NULL)
       return;
 
+    // add the obj class to the obj module
     Py_INCREF(&PyObj_Type);
     PyModule_AddObject(m, "Obj", (PyObject *)&PyObj_Type);
 }
 
+
 int PyObj_Check(PyObject *value) {
   return PyObject_TypeCheck(value, &PyObj_Type);
 }
 
 int PyObj_AsUid(PyObject *obj) {
   return ((PyObj *)obj)->uid;
+}
+
+OBJ_DATA *PyObj_AsObj(PyObject *obj) {
+  return propertyTableGet(obj_table, PyObj_AsUid(obj));
 }
 
 PyObject *
diff -ruN ../nakedmudv2.2/src/scripts/pyobj.d src/scripts/pyobj.d
--- ../nakedmudv2.2/src/scripts/pyobj.d	Thu May 12 17:08:51 2005
+++ src/scripts/pyobj.d	Fri May 27 01:33:34 2005
@@ -0,0 +1,4 @@
+scripts/pyobj.d scripts/pyobj.o: scripts/pyobj.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h world.h room.h character.h \
+  object.h races.h handler.h utils.h scripts/pyplugs.h scripts/script.h \
+  scripts/script_set.h scripts/pychar.h scripts/pyroom.h scripts/pyobj.h
diff -ruN ../nakedmudv2.2/src/scripts/pyobj.h src/scripts/pyobj.h
--- ../nakedmudv2.2/src/scripts/pyobj.h	Thu May 12 17:08:51 2005
+++ src/scripts/pyobj.h	Fri May 27 01:30:57 2005
@@ -4,18 +4,41 @@
 //
 // pyobj.h
 //
-// A python extention to allow python scripts to treat MUD objects as an
-// object within the script.
+// A python extention to allow python scripts to treat MUD obj as an
+// object within the script. If you wish to give python access to more features
+// of an obj, it should NOT be done by editing pyobj.c! Use PyObj_addGetSetter
+// and PyObj_addMethod in a new module implementing the feature you want to
+// give Python access to.
 //
 //*****************************************************************************
 
-/* initialize characters for use */
-PyMODINIT_FUNC
-init_PyObj(void);
-int PyObj_AsUid(PyObject *ch);
-int PyObj_Check(PyObject *value);
+// initialize objects for use. This must be called AFTER all other modules
+// have added in new get/setters and methods to pyobj
+PyMODINIT_FUNC init_PyObj(void);
+PyObject      *newPyObj(OBJ_DATA *obj);
 
-PyObject *
-newPyObj(OBJ_DATA *obj);
+OBJ_DATA   *PyObj_AsObj(PyObject *obj);
+int         PyObj_AsUid(PyObject *obj);
+
+//
+// checks to see of the object is a PyObj
+int         PyObj_Check(PyObject *value);
+
+//
+// getters allow Python to access pieces of the Obj module. Setters allow
+// Python to change pieces of the obj module. Getters are called when Python
+// tries to get the value of some variable on the object, and setters are called
+// when Python tries to set the value of some variable on the object. Get and
+// Set do not both need to be supplied. Examples of how to add new getters and
+// setters is presented in pyobj.c
+void PyObj_addGetSetter(const char *name, void *g, void *s, const char *doc);
+
+//
+// Adds a new method function (i.e. void *f) to the Obj class. Name is the name
+// of the function, f is the PyCFunction implementing the new method, flags is
+// the type of method beings used (almost always METH_VARARGS), and dog is an
+// (optional) description of what the method does. For examples on how to add
+// new methods, see pyobj.c
+void PyObj_addMethod(const char *name, void *f, int flags, const char *doc);
 
 #endif //__PYOBJ_H
